let new_fork () =
  let grab() | free () = busy() | reply true to grab
  and grab() | busy () = busy() | reply false to grab
  and drop() | busy () = free() in
  free() | reply grab,drop
;;

let count(x) =
  let S(x) | check() =
    if x <= 0 then {S(x) | reply false to check}
    else {S(x-1) | reply true to check} in
  S(x) | reply check
;;

let c = count(1000)
;;

let philosopher(name,grab_l,drop_l,grab_r,drop_r) =
  let think() =
    print_string("Thinking: ");
    print_string(name);
    print_newline();
    hungry()
  and hungry() =
    if grab_l() then {
      if grab_r() then {eat()}
      else {drop_l() | hungry()}
    } else {hungry()}
  and eat() =
    if c() then {
      print_string("Eating: ");
      print_string(name);
      print_newline();
      think() | drop_l() | drop_r()}
    else { drop_l() | drop_r()} in
  think()
;;

spawn
  let grab_f1,drop_f1 = new_fork()
  and grab_f2,drop_f2 = new_fork()
  and grab_f3,drop_f3 = new_fork() in
  philosopher("Platone", grab_f1, drop_f1, grab_f2, drop_f2) |
  philosopher("Socrate", grab_f2, drop_f2, grab_f3, drop_f3) |
  philosopher("Aristotele", grab_f3, drop_f3, grab_f1, drop_f1)
;;


