let new_fork () =
  let grab() | free () = busy() | reply to grab
  and drop() | busy () = free() in
  free() | reply grab,drop
;;

let new_sem (x) =
  let grab() | free(x) =
    {if x >= 1 then {free(x-1)} else {busy()}} |
    reply to grab
  and drop() | free(x) = free(x+1) | reply to drop
  and drop() | busy()  = free(1) | reply to drop in
  free(x) | reply grab,drop
;;

let sgrab,sdrop = new_sem(4)
;;

let count(x) =
  let S(x) | check() =
    if x <= 0 then {S(x) | reply false to check}
    else {S(x-1) | reply true to check} in
  S(x) | reply check
;;

let c = count(100000)
;;

let philosopher(name,grab_l,drop_l,grab_r,drop_r) =
  let think() =
    print_string("Thinking: ");
    print_string(name);
    print_newline();
    hungry()
  and hungry() =
    sgrab() ;
    print_string("Entering: ") ;
    print_string(name) ;
    print_newline() ;
    grab_l() ;
    grab_r() ;
    eat()
  and eat() =
      print_string("Eating: ");
      print_string(name);
      print_newline();
      drop_r() | drop_l() | sdrop() ; think() in
  think()
;;

spawn
  let grab_f1,drop_f1 = new_fork()
  and grab_f2,drop_f2 = new_fork()
  and grab_f3,drop_f3 = new_fork()
  and grab_f4,drop_f4 = new_fork ()
  and grab_f5,drop_f5 = new_fork () in
  philosopher("Platone", grab_f1, drop_f1, grab_f2, drop_f2) |
  philosopher("Socrate", grab_f2, drop_f2, grab_f3, drop_f3) |
  philosopher("Aristotele", grab_f3, drop_f3, grab_f4, drop_f4) |
  philosopher("Marx", grab_f4, drop_f4, grab_f5, drop_f5) |
  philosopher("Spinoza", grab_f5, drop_f5, grab_f1, drop_f1)
;;


